type EmscriptenType = 'number' | 'string' | 'boolean' | 'null';
type EmscriptenCType = 'i32';

export function cwrap(name: string, returnType: EmscriptenType, argTypes: EmscriptenType[]): (...args: any[]) => any;

export function stringToUTF8(str: string, outPtr: number, maxBytesToRead?: number): void;
export function lengthBytesUTF8(str: string): number;
export function getValue(ptr: number, type: EmscriptenCType, noSafe?: boolean): number;
export function _malloc(size: number): number;
export function _free(size: number): number;

export const HEAP8: Int8Array;

// sqlite specific things
export const stringOutPtr: number;
export const lengthOutPtr: number;
export const OPEN_READWRITE: number;
export const OPEN_CREATE: number;
export const MISUSE: number;
export const INTEGER: number;
export const FLOAT: number;
export const TEXT: number;
export const NULL: number;

export function sqliteError(code: string, msg: string, errno: number): Error;
